//+------------------------------------------------------------------+
//|                                                     SARStock.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "MY"
#property link      ""

extern double    TakeProfit=10;
extern double    StopLoss=25.0;
extern double    Lots=0.04;

static int LastBuyHour = -1;
static int LastBuyDay = -1;
static int LastSellHour = -1;
static int LastSellDay = -1;
static int WaitHour = -1;

int AddHours(int Ure)
{
   int Sum = Hour() + Ure;
   if(Sum > 23)
      Sum = Sum - 24;
   return (Sum);
}

   
//Buy exists
bool BuyExists()
{
   int count = OrdersTotal();
   for(int i = 0; i < count; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() == OP_BUY && OrderSymbol() == Symbol())
         return (true);
   }
   return (false);
}

//Sell exists
bool SellExists()
{
   int count = OrdersTotal();
   for(int i = 0; i < count; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() == OP_SELL && OrderSymbol() == Symbol())
         return (true);
   }
   return (false);
}

int start()
{
   if(WaitHour == Hour())
      WaitHour = -1;
   if(WaitHour != -1)
      return (0);

   double Sar1 = iSAR(NULL, 60, 0.1, 0.2, 1);
   double Sar = iSAR(NULL, 60, 0.1, 0.2, 0);
   double MA5 = iMA(NULL, 60, 5, 0, MODE_EMA, PRICE_CLOSE, 0 ) ;
   double MA12 = iMA(NULL, 60, 12, 0, MODE_EMA, PRICE_CLOSE, 0 ) ;
   double MA34 = iMA(NULL, 60, 34, 0, MODE_EMA, PRICE_CLOSE, 0 ) ;
   
   bool Buy = (( MA5 > MA12 ) && ( MA12 > MA34 ) && ( Sar1 > MA5 ) && ( Sar < MA5 ));
   bool Sell = (( MA5 < MA12 ) && ( MA12 < MA34 ) && ( Sar1 < MA5 ) && ( Sar > MA5 ));
   
   
   int ticket;


   if(Buy)
   {
      if(!BuyExists())
      {
         Print("Sar - BUY!");

         RefreshRates();
         ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask - StopLoss * Point, Ask + TakeProfit * Point, "Sar is on FIRE!", MathRand() , 0, Green);
         if(ticket == -1)
            Print("Buy error: ", GetLastError());
         else
         {
            LastBuyHour = Hour();
            LastBuyDay = Day();
           
         }
         WaitHour = AddHours(1);
      }
   }

   if(Sell)
   {
      if(!SellExists())
      {
         Print("Sar - SELL!");
         RefreshRates();
         ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid + StopLoss * Point, Bid - TakeProfit * Point, "Sar is on FIRE!", MathRand(), 0, Red);
         if(ticket == -1)
            Print("Sell error: ", GetLastError());
         else
         {
            LastSellHour = Hour();
            LastSellDay = Day();

         }
         WaitHour = AddHours(1);
      }
   }
   return(0);
}
int init()
{
   return(0);
}
int deinit()
{
   return(0);
}